// Example using my interface to stb-truetype, an amazing single file
// truetype font reader, part of the stb library/collection by
// Sean Barrett.

// I am still using the 2013 version since it is small (81k) and
// it works just fine. I have also tested with the 2021 version.

// By Ingemar Ragnemalm. First version with the revised interface 2023.
// Minimal dependencies! Interfaces to anything!

#include "MicroGlut.h"
#include "my-stbtt-lib.h"
#include <stdio.h>
// uses framework OpenGL
// uses framework Cocoa

long gWidth=400, gHeight=400;
stbfont *f, *f2, *f3; // The fonts
int count = 0;

void display(void)
{
	// clear the screen
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	
	my_stbtt_set_color(1, 1, 1);
	my_stbtt_print(10, 100, "This is a demo of stb TrueType", f);
	my_stbtt_print(10, 150, "text rendering with OpenGL", f);
	my_stbtt_print(100, 250, "Can mix fonts too", f2);
	my_stbtt_set_color(1, 0, 0);
	my_stbtt_print(100, 300, "and colors", f);
	my_stbtt_set_color(0, 1, 0);
	my_stbtt_print(100, 350, "It is all in the wrist.", f2);
	my_stbtt_set_color(1, 1, 0);
	my_stbtt_print(100, 400, "I load each size explicitly.", f3);

	float x = my_stbtt_print(30, 500, "Text ", f);
	my_stbtt_set_color(1, 0, 0);
	x = my_stbtt_print(x, 500, "can go on ", f);
	my_stbtt_set_color(1, 0, 1);
	x = my_stbtt_print(x, 500, "and on", f);

//	char buffer[1024];
//	sprintf(buffer, "%d", count++);
//	my_stbtt_print(10, 400, buffer, f3);

// I almost like this... but I would prefer to include rotation,
// dynamic sizes, dynamic styles, and print a line in several parts.
// Can I add that?

	glutSwapBuffers();
}

void reshape(int w, int h)
{
	gWidth = w;
	gHeight = h;
	glViewport(0, 0, w, h);

	printf("reshape to %d %d\n", w, h);
}

void init()
{
	glClearColor(0.2,0.2,0.5,0);
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	
	my_stbtt_init();
	f = my_stbtt_initfont("pdfonts/qumpellkano12.ttf", 64.0);
	f2 = my_stbtt_initfont("pdfonts/linux-libertine.ttf", 32.0);
	f3 = my_stbtt_initfont("pdfonts/schwaben-alt.ttf", 48.0);
}

int main(int argc, char *argv[])
{
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_RGBA | GLUT_DEPTH | GLUT_DOUBLE);
	glutInitWindowSize(840, 600);
	glutInitContextVersion(3, 2);
	glutCreateWindow ("stbtt example");
	glutDisplayFunc(display); 
	glutReshapeFunc(reshape);
	init ();
	reshape(400, 400);
	glutMainLoop();
}
