#ifndef STBTTLIB
#define STBTTLIB

#ifdef __APPLE__
	#define GL_SILENCE_DEPRECATION
	#include <OpenGL/gl3.h>
#else
	#if defined(_WIN32)
		#include "glew.h"
		#include <GL/gl.h>
	#else
		#include <GL/gl.h>
	#endif
#endif

#include "stb_truetype.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct stbfont
{
	stbtt_bakedchar cdata[96]; // ASCII 32..126 is 95 glyphs
	//GLstbtt_uint ftex
	unsigned int ftex;
} stbfont;

stbfont *my_stbtt_initfont(const char *fontName, float fontsize);
void my_stbtt_init();
float my_stbtt_print(float x, float y, const char *text, stbfont *f);
void my_stbtt_set_color(float r, float g, float b);

#ifdef __cplusplus
}
#endif

#endif
